Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | List of all members
DL_GroupParameters_IntegerBased Class Referenceabstract

Integer-based GroupParameters specialization. More...

Inheritance diagram for DL_GroupParameters_IntegerBased:

## Public Member Functions
void | Initialize (const DL_GroupParameters_IntegerBased &params)
| Initialize a group parameters over integers. More...
void | Initialize (RandomNumberGenerator &rng, unsigned int pbits)
| Create a group parameters over integers. More...
void | Initialize (const Integer &p, const Integer &g)
| Initialize a group parameters over integers. More...
void | Initialize (const Integer &p, const Integer &q, const Integer &g)
| Initialize a group parameters over integers. More...
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
| Generate a random key. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key. More...
const Integer & | GetSubgroupOrder () const
| Retrieves the subgroup order. More...
Integer | GetGroupOrder () const
| Retrieves the order of the group. More...
bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const
| Check the group for errors. More...
bool | ValidateElement (unsigned int level, const Integer &element, const DL_FixedBasePrecomputation< Integer > *precomp) const
bool | FastSubgroupCheckAvailable () const
| Determine if subgroup membership check is fast. More...
void | EncodeElement (bool reversible, const Element &element, byte *encoded) const
| Encodes the element. More...
unsigned int | GetEncodedElementSize (bool reversible) const
| Retrieve the encoded element's size. More...
Integer | DecodeElement (const byte *encoded, bool checkForGroupMembership) const
| Decodes the element. More...
Integer | ConvertElementToInteger (const Element &element) const
| Converts an element to an Integer. More...
Integer | GetMaxExponent () const
| Retrieve the maximum exponent for the group. More...
OID | GetAlgorithmID () const
| Retrieve the OID of the algorithm. More...
virtual const Integer & | GetModulus () const =0
| Retrieve the modulus for the group. More...
virtual void | SetModulusAndSubgroupGenerator (const Integer &p, const Integer &g)=0
| Set group parameters. More...
void | SetSubgroupOrder (const Integer &q)
| Set subgroup order. More...
Public Member Functions inherited from ASN1CryptoMaterial< DL_GroupParameters< Integer > >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from DL_GroupParameters< T >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
virtual const Element & | GetSubgroupGenerator () const
| Retrieves the subgroup generator. More...
virtual void | SetSubgroupGenerator (const Element &base)
| Sets the subgroup generator. More...
virtual Element | ExponentiateBase (const Integer &exponent) const
| Exponentiates the base. More...
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
| Exponentiates an element. More...
virtual const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const =0
| Retrieves the group precomputation. More...
virtual const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const =0
| Retrieves the group precomputation. More...
virtual DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()=0
| Retrieves the group precomputation. More...
virtual Integer | GetCofactor () const
| Retrieves the cofactor. More...
virtual bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const =0
| Check the element for errors. More...
virtual bool | IsIdentity (const Element &element) const =0
| Determines if an element is an identity. More...
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const =0
| Exponentiates a base to multiple exponents. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Static Public Member Functions
static std::string | StaticAlgorithmNamePrefix ()
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Additional Inherited Members
Public Types inherited from DL_GroupParameters< T >
typedef T | Element

## Detailed Description

Integer-based GroupParameters specialization.

Definition at line 34 of file gfpcrypt.h.

## Member Function Documentation

## ◆ Initialize() [1/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | const DL_GroupParameters_IntegerBased & | params | ) |
| inline

Initialize a group parameters over integers.

Parameters

  params | the group parameters

Definition at line 43 of file gfpcrypt.h.

## ◆ Initialize() [2/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | pbits
| ) |  |
| inline

Create a group parameters over integers.

Parameters

  rng | a RandomNumberGenerator derived class
  pbits | the size of p, in bits

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 52 of file gfpcrypt.h.

## ◆ Initialize() [3/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | const Integer & | p,
|  | const Integer & | g
| ) |  |
| inline

Initialize a group parameters over integers.

Parameters

  p | the modulus
  g | the generator

Definition at line 58 of file gfpcrypt.h.

## ◆ Initialize() [4/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | g
| ) |  |
| inline

Initialize a group parameters over integers.

Parameters

  p | the modulus
  q | the subgroup order
  g | the generator

Definition at line 65 of file gfpcrypt.h.

## ◆ BERDecode()

void DL_GroupParameters_IntegerBased::BERDecode | ( | BufferedTransformation & | bt | ) |
| virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Implements ASN1Object.

## ◆ DEREncode()

void DL_GroupParameters_IntegerBased::DEREncode | ( | BufferedTransformation & | bt | ) | const
| virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Implements ASN1Object.

## ◆ GenerateRandom()

void DL_GroupParameters_IntegerBased::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) |  |
| virtual

Generate a random key.

Parameters

  rng | a RandomNumberGenerator to produce keying material
  alg | additional initialization parameters

Recognised NameValuePairs are ModulusSize and SubgroupOrderSize (optional)

Exceptions

  KeyingErr | if a key can't be generated or algorithm parameters are invalid

Reimplemented from GeneratableCryptoMaterial.

## ◆ GetVoidValue()

bool DL_GroupParameters_IntegerBased::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Reimplemented in DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >.

## ◆ AssignFrom()

void DL_GroupParameters_IntegerBased::AssignFrom | ( | const NameValuePairs & | source | ) |
| virtual

Initialize or reinitialize this key.

Parameters

  source | NameValuePairs to assign

Implements CryptoMaterial.

Reimplemented in DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >.

## ◆ GetSubgroupOrder()

const Integer& DL_GroupParameters_IntegerBased::GetSubgroupOrder | ( |  | ) | const
| inline virtual

Retrieves the subgroup order.

Returns
  the order of subgroup generated by the base element

Implements DL_GroupParameters< T >.

Definition at line 98 of file gfpcrypt.h.

## ◆ GetGroupOrder()

Integer DL_GroupParameters_IntegerBased::GetGroupOrder | ( |  | ) | const
| inline virtual

Retrieves the order of the group.

Returns
  the order of the group

Either GetGroupOrder() or GetCofactor() must be overridden in a derived class.

Reimplemented from DL_GroupParameters< T >.

Definition at line 99 of file gfpcrypt.h.

## ◆ ValidateGroup()

bool DL_GroupParameters_IntegerBased::ValidateGroup | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| virtual

Check the group for errors.

Parameters

  rng | RandomNumberGenerator for objects which use randomized testing
  level | level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

ValidateGroup() must be implemented in a derived class.

Implements DL_GroupParameters< T >.

## ◆ FastSubgroupCheckAvailable()

bool DL_GroupParameters_IntegerBased::FastSubgroupCheckAvailable | ( |  | ) | const
| inline virtual

Determine if subgroup membership check is fast.

Returns
  true or false

Implements DL_GroupParameters< T >.

Definition at line 105 of file gfpcrypt.h.

## ◆ EncodeElement()

void DL_GroupParameters_IntegerBased::EncodeElement | ( | bool | reversible,
|  | const Element & | element,
|  | byte * | encoded
| ) |  | const
| virtual

Encodes the element.

Parameters

  reversible | flag indicating the encoding format
  element | reference to the element to encode
  encoded | destination byte array for the encoded element

EncodeElement() must be implemented in a derived class.

Precondition
  `COUNTOF(encoded) == GetEncodedElementSize()`

See also
  GetEncodedElementSize(), DecodeElement(), Cygwin i386 crash at -O3

Implements DL_GroupParameters< T >.

## ◆ GetEncodedElementSize()

unsigned int DL_GroupParameters_IntegerBased::GetEncodedElementSize | ( | bool | reversible | ) | const
| virtual

Retrieve the encoded element's size.

Parameters

  reversible | flag indicating the encoding format

Returns
  encoded element's size, in bytes

The format of the encoded element varies by the underlying type of the element and the reversible flag.

See also
  EncodeElement(), DecodeElement()

Implements DL_GroupParameters< T >.

## ◆ DecodeElement()

Integer DL_GroupParameters_IntegerBased::DecodeElement | ( | const byte * | encoded,
|  | bool | checkForGroupMembership
| ) |  | const
| virtual

Decodes the element.

Parameters

  encoded | byte array with the encoded element
  checkForGroupMembership | flag indicating if the element should be validated

Returns
  Element after decoding

DecodeElement() must be implemented in a derived class.

Precondition
  `COUNTOF(encoded) == GetEncodedElementSize()`

See also
  GetEncodedElementSize(), EncodeElement()

Implements DL_GroupParameters< T >.

## ◆ ConvertElementToInteger()

Integer DL_GroupParameters_IntegerBased::ConvertElementToInteger | ( | const Element & | element | ) | const
| inline virtual

Converts an element to an Integer.

Parameters

  element | the element to convert to an Integer

Returns
  Element after converting to an Integer

ConvertElementToInteger() must be implemented in a derived class.

Implements DL_GroupParameters< T >.

Definition at line 139 of file gfpcrypt.h.

## ◆ GetMaxExponent()

Integer DL_GroupParameters_IntegerBased::GetMaxExponent | ( |  | ) | const
| virtual

Retrieve the maximum exponent for the group.

Returns
  the maximum exponent for the group

Implements DL_GroupParameters< T >.

## ◆ GetAlgorithmID()

OID DL_GroupParameters_IntegerBased::GetAlgorithmID | ( |  | ) | const

Retrieve the OID of the algorithm.

Returns
  OID of the algorithm

## ◆ GetModulus()

virtual const Integer& DL_GroupParameters_IntegerBased::GetModulus | ( |  | ) | const
| pure virtual

Retrieve the modulus for the group.

Returns
  the modulus for the group

Implemented in DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >.

## ◆ SetModulusAndSubgroupGenerator()

virtual void DL_GroupParameters_IntegerBased::SetModulusAndSubgroupGenerator | ( | const Integer & | p,
|  | const Integer & | g
| ) |  |
| pure virtual

Set group parameters.

Parameters

  p | the prime modulus
  g | the group generator

Implemented in DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >.

## ◆ SetSubgroupOrder()

void DL_GroupParameters_IntegerBased::SetSubgroupOrder | ( | const Integer & | q | ) |
| inline

Set subgroup order.

Parameters

  q | the subgroup order

Definition at line 161 of file gfpcrypt.h.

The documentation for this class was generated from the following file:

- gfpcrypt.h